/**
 * Copyright (c) 2008 Mia-Software. 
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0 
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributor: 
 *     Fabien Giquel
 */

package org.eclipse.gmt.modisco.discoverer.kdm.source.popup.actions;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.xmi.XMIResource;

public class Tools {
	
	public static boolean saveModel(Resource resource, String outputLocation){
		boolean success = true;
		Map<String, String> options = new HashMap<String, String>();			
		options.put(XMIResource.OPTION_ENCODING, "ISO-8859-1");	

		URI outputURI = URI.createFileURI(outputLocation);
		resource.setURI(outputURI);
		try {
			resource.save(options);
		} catch (IOException e) {
			success = false;
			e.printStackTrace();
		}
		return success;

	}

}
